% APRENDIZAJE AUTOMÁTICO (G. Pajares y J.M. de la Cruz, Eds.)
% Editorial: RA-MA
% Capítulo 1: Introducción
% Autores: Jesús Manuel de la Cruz García, Gonzalo Pajares Martinsanz
%
% sc_fdp
%
% Ejemplo de estima de una función de densidad de probabilidad 
% Ejemplo de la sección 1.4.3 y figura 1.10

% Generación de muestras por una densidad de probabilidad normal
m=4;        % Valor medio de la función densidad de probabilidad
s=2;        % Desviación estándar de la función densidad de probabilidad
data=m+randn(20,1)*s;   % Observaciones o muestras            % 
subplot(211),plot(data,'b*'),hold on
title('muestras')

% Representación gráfica de la fdp generadora de las muestras
t=-2:.1:10; 
y=zeros(size(t));
for i=1:size(t,2),      
    y(i)=1/sqrt(2*pi)/s*exp(-(t(i)-m)^2/2/s/s); 
end
subplot(212),plot(t,y), hold on
title('densidad de probabilidad')

% estima del valor medio y la desviación estándar de la fdp
alfa0 = [1,1];   % estima inicial de m y s
alfa=fminsearch(@fun7,alfa0,[],data)
f=fun7(alfa,data)

% Gráfica de la densidad de probabilidad estimada
y=zeros(size(t));
me=alfa(1);se=alfa(2);
for i=1:size(t,2),
    ye(i)=1/sqrt(2*pi)/se*exp(-(t(i)-me)^2/2/se/se); 
end
subplot(212),plot(t,ye,'r:'),
legend('real','estimada')